#!/usr/bin/perl

# this code is for evaluation only.  it assumes that the first n
# positions are attributes, and the next is the label.  it outputs
# the labels in sorted order, as well as the examples with the
# scores appended

# IT ASSUMES THAT THE EXAMPLES ARE SEPARATED BY WHITE SPACE, NOT COMMAS
#

$| = 1;


if (scalar(@ARGV) < 3) {
    die "Usage: $0 <prefix> <num_features> <label_file> <example_file> -switch1 val1 ...";}

$prefix = shift @ARGV;
$n = shift @ARGV;
$label_file = shift @ARGV;
$example_file = shift @ARGV;

while(scalar(@ARGV) > 0) {
  if (scalar(@ARGV) == 1 || !($ARGV[0] =~ /^\-/)) {
    die "Usage: $0 <prefix> <score_file> -switch1 val1 ...";}

  $varname = shift @ARGV;
  $varname =~ s/^\-//;
  $val = shift @ARGV;
  ${$varname} = $val;}

if (!(-e "temp") || !(-d "temp")) {
  system "mkdir temp";}

$temp_prefix = "temp/" . int(rand(100000000000));
# $temp_prefix = "test";

system "sed 's/?/0.0/g' $prefix.data > $temp_prefix.data";
system "awk '\$NF != \"?\"' $prefix.data | sed 's/?/0.0/g' > $temp_prefix.test";
for($i = 0; $i < $n; $i++) {
  print "Preprocessing variable $i\n";
  $i_plus_1 = $i + 1;
  system "awk '{ print \$$i_plus_1 }' $temp_prefix.data | sort -nr > $temp_prefix.data$i";}

$num_training = `cat $prefix.data | wc -l`;
$num_test = `cat $temp_prefix.test | wc -l`;
chomp($num_training);
chomp($num_test);
print "calling peer_rank $temp_prefix $num_training $num_test $n\n";
system "peer_rank $temp_prefix $num_training $num_test $n";
print "peer_rank returned, sorting by scores\n";
system "awk '{ print \$(NF-1), \$NF, rand() }' $temp_prefix.output | sort -nr +1 +2 | awk '{ print \$1 }' > $label_file";
system "mv $temp_prefix.output $example_file";

print "\n";
system "perl auc.pl $label_file";
system "rm $temp_prefix.*";

